const btc = require("bitcoinjs-lib");

function sign(wif,signdata){
    //一个wif对应一个地址，此方法适用于一个私钥签名
    const keyPair = btc.ECPair.fromWIF(wif);

    const tx = new btc.TransactionBuilder();
    tx.setVersion(1);
    //将字符串转化为json
    const data = JSON.parse(signdata);

    data.input.forEach(function (input) {
        tx.addInput(input.txid,input.vout);
    })

    data.output.forEach(function (output) {
        tx.addOutput(output.address, output.value);
    })

    data.input.forEach(function (input) {
        tx.sign(input.vout, keyPair);
    })
    return tx.build().toHex();
}

module.exports={
    signTransaction:sign
}

