const btc = require("bitcoinjs-lib");

function sign(wif,signdata){
    const net = btc.networks.testnet;
    const keyPair = btc.ECPair.fromWIF(wif, net);
    const p2wpkh = btc.payments.p2wpkh({pubkey: keyPair.publicKey, network: net})
    const p2sh = btc.payments.p2sh({redeem: p2wpkh, network: net})

    const tx = new btc.TransactionBuilder(net);
    tx.setVersion(2);


    //signdata form
    /*  const data = {
          input: [{
              txid: '58aab89435bad892ff0817f5296d48faa564dfc369b12121c2e5521ec5f7db0b',
              vout: '0',
              value: 9000000
          }, {
              txid: '31f4d3025a026738ab45b62078c64924f26eee5c7bd1ca5b8f84a46be6e963c9',
              vout: '1',
              value: 8000000
          }],
          output: [{
              address: '2NGVjpAzsd9JPnm1jKHeJtNk3e1FBsCHXZU',
              value: 1000000
          }, {
              address: 'mm7J6MznV7am7em3n67YMTN3tNZGcUwc22',
              value: 2000000
          }, {
              address: 'mhaYYpHQg7jPvShGPKgRYuGK2bmXsNaRwM',
              value: 1350000
          }]
      }*/

    //将字符串转化为json
    const data = JSON.parse(signdata);

    data.input.forEach(function (input) {
        // console.log(input.txid)
        // console.log(input.vout)
        // console.log(input.value)
        tx.addInput(input.txid,input.vout);
    })

    data.output.forEach(function (output) {
        // console.log(output.address)
        // console.log(output.value)
        tx.addOutput(output.address, output.value);
    })

    data.input.forEach(function (input) {
        tx.sign(input.vout, keyPair, p2sh.redeem.output, null, input.value);
    })

    return tx.build().toHex();
}

module.exports={
    signTransaction:sign
}