//验证通过
const bitcoin = require("bitcoinjs-lib");
const net = bitcoin.networks.testnet;
const keyPair = bitcoin.ECPair.fromWIF("cTDMViKByraUgTryu2bUrv4nj9KF6tjhb9gj1vy9SEQeFQH6hcjL", net);
const p2wpkh = bitcoin.payments.p2wpkh({ pubkey: keyPair.publicKey, network: net })
const p2sh = bitcoin.payments.p2sh({ redeem: p2wpkh, network: net })

const tx = new bitcoin.TransactionBuilder(net);
//input需要：
//1.txid 2.vout 3.utxo的value就可以
tx.setVersion(2);
tx.addInput("58aab89435bad892ff0817f5296d48faa564dfc369b12121c2e5521ec5f7db0b", 0);
//output需要：
//1.address 2.value
//及时output的地址系相同，在区块链中也是两个UTXO
tx.addOutput("2NGVjpAzsd9JPnm1jKHeJtNk3e1FBsCHXZU", 99980000);
//留足够的旷工费之后，还需要设置剩余返回的地址和余额
//最后一个值是utxo的value、换算为单位聪
//输入多个output就相当于多笔输出，可用来做批量签名
//这边再验证下，如果有多个input的时候，最后一个参数应该输入多少，累加么？
tx.sign(0, keyPair, p2sh.redeem.output, null, 99990000);
//miner fee=(99990000-99980000)/10^8

console.log(tx.build().toHex());

//签名成功的例子：https://tchain.btc.com/96cc1a6a935b96f98ebf91022a494701617943912967643636b5ae00c7eec647

