const bitcoin = require("bitcoinjs-lib");
const net = bitcoin.networks.testnet;
//2NGVrf6xxPqrv5eEQDBCBvZncLNTrTFgHD1:cTDMViKByraUgTryu2bUrv4nj9KF6tjhb9gj1vy9SEQeFQH6hcjL
//2NGVjpAzsd9JPnm1jKHeJtNk3e1FBsCHXZU:cVw2cVReRJ93Md6ftLWBoQkFbAhTRukeCcrgJQXUhTFufrafrw5o
//多对多的这种情况 input------>wif 需要对应起来
//2NGVjpAzsd9JPnm1jKHeJtNk3e1FBsCHXZU
const keyPair1 = bitcoin.ECPair.fromWIF("cVw2cVReRJ93Md6ftLWBoQkFbAhTRukeCcrgJQXUhTFufrafrw5o", net);
//2NGVrf6xxPqrv5eEQDBCBvZncLNTrTFgHD1
const keyPair2 = bitcoin.ECPair.fromWIF("cTDMViKByraUgTryu2bUrv4nj9KF6tjhb9gj1vy9SEQeFQH6hcjL", net);

const p2wpkh1 = bitcoin.payments.p2wpkh({ pubkey: keyPair1.publicKey, network: net })
const p2sh1 = bitcoin.payments.p2sh({ redeem: p2wpkh1, network: net })

const p2wpkh2 = bitcoin.payments.p2wpkh({ pubkey: keyPair2.publicKey, network: net })
const p2sh2 = bitcoin.payments.p2sh({ redeem: p2wpkh2, network: net })
//keypair->publickey->p2wpkh->p2sh


const tx = new bitcoin.TransactionBuilder(net);
tx.setVersion(2);
//2NGVjpAzsd9JPnm1jKHeJtNk3e1FBsCHXZU
tx.addInput("6252a6c0fa51825be4b1513c39828469bd689682c747eb8f4cdf9cc79b286249", 0);//10000000
tx.addInput("6252a6c0fa51825be4b1513c39828469bd689682c747eb8f4cdf9cc79b286249", 1);//10000000

//2NGVrf6xxPqrv5eEQDBCBvZncLNTrTFgHD1
tx.addInput("6252a6c0fa51825be4b1513c39828469bd689682c747eb8f4cdf9cc79b286249", 2);//79900000


tx.addOutput("2NGSFLMYWLXBdSbbAtDkiEkoVWaFJm1HdpQ", 49890000);
tx.addOutput("2NGJNhE16ZUwjw3UQzKCQqoHBKma2k43SUx", 50000000);

//2NGVjpAzsd9JPnm1jKHeJtNk3e1FBsCHXZU
tx.sign(0, keyPair1, p2sh1.redeem.output, null, 10000000);
tx.sign(1, keyPair1, p2sh1.redeem.output, null, 10000000);
//2NGVrf6xxPqrv5eEQDBCBvZncLNTrTFgHD1
tx.sign(2, keyPair2, p2sh2.redeem.output, null, 79900000);

console.log(tx.build().toHex());


//https://tchain.btc.com/2NGVrf6xxPqrv5eEQDBCBvZncLNTrTFgHD1


